
// Must be the first header
#include <Python.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../../augh/auto/auto.h"
#include "../../augh/plugins/plugins.h"
#include "../../augh/auto/command.h"
#include "exec_python.h"



typedef struct aughcmd_py_t  aughcmd_py_t;
struct aughcmd_py_t {
	implem_t* Implem;
	// To process command
	PyObject* self;
	PyObject* args;
	// The result
	PyObject* res;
};

static command_t* shared_py_cmd_data = NULL;


//================================
// The command callbacks
//================================

static PyObject* callback_cmd_augh(PyObject *self, PyObject *args){
	command_t* cmd_data = shared_py_cmd_data;

	// Set fields, completely phony
	aughcmd_py_t* cmd_pydata = cmd_data->data;
	cmd_pydata->self = self;
	cmd_pydata->args = args;

	// Parse the command, just a bit string
	const char* str_const;
	if(!PyArg_ParseTuple(args, "s", &str_const)) return NULL;

	char* str = strdup(str_const);
	cmd_data->data_command = str;

	// Execute the command with augh
	cmd_pydata->res = NULL;
	int z = AughCmd_Exec(cmd_pydata->Implem, cmd_data);

	// Clean
	free(str);

	// Return the result generated by the callback
	if(cmd_pydata->res != NULL) return cmd_pydata->res;

	// FIXME Handle non-zero as error
	return PyLong_FromLong(z);
}

//================================
// Declarations for Python
//================================

static PyMethodDef EmbMethods[] = {
	// Just one command for now
	{"cmd", callback_cmd_augh, METH_VARARGS, "Call augh built-in command interpreter"},
	// End of declarations
	{NULL, NULL, 0, NULL}
};

static PyModuleDef EmbModule = {
	PyModuleDef_HEAD_INIT, "augh", NULL, -1, EmbMethods,
	NULL, NULL, NULL, NULL
};

static PyObject* PyInit_augh(void) {
	return PyModule_Create(&EmbModule);
}

//================================
// Declarations for Augh
//================================

// The callback to get one command word, for AUGH embedded command interpreter
static void Command_callback_result_finish(command_t* cmd_data) {
	if(cmd_data->list_res == NULL) return;

	aughcmd_py_t* cmd_pydata = cmd_data->data;

	// One element
	if(cmd_data->list_res->NEXT == NULL) {
		cmd_pydata->res = PyUnicode_FromString((char*)cmd_data->list_res->DATA);
	}
	// Multiple elements
	else {
		cmd_data->list_res = reverse(cmd_data->list_res);
		unsigned nb = ChainList_Count(cmd_data->list_res);
		PyObject* tuple = PyTuple_New(nb);
		unsigned idx = 0;
		foreach(cmd_data->list_res, scanRes) {
			PyObject* val = PyUnicode_FromString((char*)scanRes->DATA);
			PyTuple_SetItem(tuple, idx++, val);
		}
		cmd_pydata->res = tuple;
	}

}

// Main function to call TCL interpreter
int exec_python_file(implem_t* Implem, const char* filename) {

	// Open the file
	FILE* F = fopen(filename, "rb");
	if(F==NULL) {
		printf("Error : Can't open file %s.\n", filename);
		return -1;
	}

	// Data structure to launch execution of commands
	command_t cmd_data_i;
	command_t* cmd_data = &cmd_data_i;
	memset(cmd_data, 0, sizeof(*cmd_data));
	// Data structure to store status of parsing of current command
	aughcmd_py_t cmd_pydata_i;
	aughcmd_py_t* cmd_pydata = &cmd_pydata_i;
	memset(cmd_pydata,  0, sizeof(*cmd_pydata));

	// Init fields
	cmd_data->data = cmd_pydata;
	cmd_data->callback_nextword = AughCmd_callback_nextword;
	cmd_data->callback_editbuf  = AughCmd_callback_editbuf;
	cmd_data->callback_result_finish = Command_callback_result_finish;
	// Init fields
	cmd_pydata->Implem = Implem;

	// Set shared variables
	shared_py_cmd_data = cmd_data;

	// Stuff to prepare Python environment
	wchar_t *program = Py_DecodeLocale(Implem->env.globals->argv0, NULL);
	if (program == NULL) {
		fprintf(stderr, "Fatal error: cannot decode argv[0]\n");
		exit(1);
	}

	// Declare the new Python Module: augh
	PyImport_AppendInittab("augh", &PyInit_augh);

	// Optional but recommended
	Py_SetProgramName(program);

	// Initialization of the Python interpreter
	Py_Initialize();

	// Execute
	PyRun_SimpleFile(F, filename);

	// Clean
	if (Py_FinalizeEx() < 0) {
		exit(120);
	}
	PyMem_RawFree(program);

	return 0;
}

